// CIRL GPU GLSL Geometry Shader Code
// Derek Anderson and Robert Luke
// http://cirl.missouri.edu/gpu/glsl_lessons/glsl_geometry_shader/index.html
// LTCg̃\[XR[hς܂B

#include <windows.h>

#include <GL/glew.h>
#include <GL/glut.h>
#include <math.h>

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <deque>
#include <numeric>

#define INPUT_TYPE GL_TRIANGLES
#define OUTPUT_TYPE GL_TRIANGLES

// O[oϐ
// o[fbNXAtOgAWIgVF[_AvOւ̃nh
GLuint vertexShader, fragmentShader, geometryShader, program;	

// EBhE̕ƍ̕ێp
int windowWidth, windowHeight;			
double fovy = 45.0;
double zNear = 1.0;
double zFar = 100.0;

const double M_PI = 4.0*atan(1.0);

// _W
GLfloat eye[]= { 4.0, 3.0, 3.0 };
GLfloat center[] = { 0.0, 0.0, 0.0 };
GLfloat up[] = {0.0, 1.0, 0.0 };

float theta = 0;

// 
GLfloat lightPos[] = { 0, 3.0, 5.0, 1 };
GLfloat lightCol[] = { 1 , 1 , 1 , 1 };
GLfloat lightAmb[] = { 0.3, 0.3, 0.3, 1};
GLfloat lightSpecular[] = { 0.8, 0.8, 0.8, 1.0};
static GLfloat diffuse[] = {0.6, 0.6, 0.6, 1.0};
GLfloat shininess = 100.0f;

// ֐̎Ql: http://www.evl.uic.edu/aej/594/code/ogl.cpp
// eLXgt@Cǂݍ (GLSL program)
// GLSLhCoɕƂēnKv܂B
char *textFileRead(char *fn) 
{
	FILE *fp;
	char *content = NULL;

	int count=0;

	if (fn != NULL) {
		
		fp = fopen(fn,"rt");

		if (fp != NULL) {
      
        		fseek(fp, 0, SEEK_END);
        		count = ftell(fp);
        		rewind(fp);

			if (count > 0) {
				content = (char *)malloc(sizeof(char) * (count+1));
				count = fread(content,sizeof(char),count,fp);
				content[count] = '\0';
			}
			fclose(fp);
		
		}
	}

	return content;
}

// ֐̎Ql: http://www.evl.uic.edu/aej/594/code/ogl.cpp
// eLXgt@C̏ (GLSL program)
// eLXgt@C݂̏Ɏgpł֐łB
int textFileWrite(char *fn, char *s) 
{
	FILE *fp;
	int status = 0;

	if (fn != NULL) {
		fp = fopen(fn,"w");

		if (fp != NULL) {
			
			if (fwrite(s,sizeof(char),strlen(s),fp) == strlen(s))
				status = 1;
			fclose(fp);
		}
	}
	return(status);
}

// QlF http://www.lighthouse3d.com/opengl/glsl/index.php?oglinfo
// VF[_̕\ (fobOp)
void printShaderInfoLog(GLuint obj)
{
    int infologLength = 0;
    int charsWritten  = 0;
    char *infoLog;
    glGetShaderiv(obj, GL_INFO_LOG_LENGTH,&infologLength);
    if (infologLength > 0)
    {
        infoLog = (char *)malloc(infologLength);
        glGetShaderInfoLog(obj, infologLength, &charsWritten, infoLog);
		printf("printShaderInfoLog: %s\n",infoLog);
        free(infoLog);
	}else{
		printf("Shader Info Log: OK\n");
	}
}

// QlF http://www.lighthouse3d.com/opengl/glsl/index.php?oglinfo
// VF[_vO̕\ (fobOp)
void printProgramInfoLog(GLuint obj)
{
    int infologLength = 0;
    int charsWritten  = 0;
    char *infoLog;
	glGetProgramiv(obj, GL_INFO_LOG_LENGTH,&infologLength);
    if (infologLength > 0)
    {
        infoLog = (char *)malloc(infologLength);
        glGetProgramInfoLog(obj, infologLength, &charsWritten, infoLog);
		printf("printProgramInfoLog: %s\n",infoLog);
        free(infoLog);
    }else{
		printf("Program Info Log: OK\n");
	}
}

// GLUTR[obN֐
// EBhETCYύX
void changeSize(int w, int h) 
{
	// EBhE̕ƍi[
	windowWidth = w;
	windowHeight = h;
	// r[|[g̐ݒ
	glViewport(0, 0, windowWidth, windowHeight);
	// vWFNV[hւ̕ύX
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	// eŕ\ 
    gluPerspective(fovy, (GLfloat)windowWidth/(GLfloat)windowHeight, zNear, zFar);
	// fr[[hɖ߂
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void renderScene(void) 
{
	// wiNA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// _̐ݒ
	// fr[[hɖ߂
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(eye[0]*cos(theta), eye[1], eye[2]*sin(theta), center[0], center[1], center[2], up[0], up[1], up[2]);
	
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	glPointSize(5.0);

	glUseProgram(program);
	// eB[|bg̕`
	glutSolidTeapot(1.0);
	glUseProgram(0);

    // ̕\
    glPushMatrix();
    glTranslatef(0, -6.0, 0);
    glutSolidCube(10.0);
    glPopMatrix();

	glDisable(GL_LIGHTING);

	// obt@̌
	glutSwapBuffers();
	glFinish();

	theta += 0.01;
	if (theta > M_PI*2)
	{
		theta = 0;
	}
}

// GLUT̃R[obN֐
// L[ꂽƂ̏
void processNormalKeys(unsigned char key, int x, int y) 
{
	switch (key)
	{
	// ESC
	case 27: 
		exit(0);
		break;
	}
}

// VF[_̐ݒ
void setShaders() 
{
	// t@C
	char *vertexString = NULL, *fragmentString = NULL, *geometryString = NULL;

	// ŏɃVF[_쐬
	vertexShader   = glCreateShader(GL_VERTEX_SHADER);
	fragmentShader = glCreateShader(GL_FRAGMENT_SHADER);
	geometryShader = glCreateShader(GL_GEOMETRY_SHADER_EXT);

	// vO̓ǂݍ
	vertexString   = textFileRead("../GLSL/shader.vert");
	fragmentString = textFileRead("../GLSL/shader.frag");
	geometryString = textFileRead("../GLSL/shader.geom");

	// |C^̐ݒ
	const char *ff = fragmentString;
	const char *vv = vertexString;
	const char *gg = geometryString;

	glShaderSource(vertexShader,   1, &vv, NULL);
	glShaderSource(fragmentShader, 1, &ff, NULL);
	glShaderSource(geometryShader, 1, &gg, NULL);

	// ̉
	free(vertexString);
	free(fragmentString);
	free(geometryString);

	// \[X̃RpC
	glCompileShader(vertexShader);
	glCompileShader(fragmentShader);
	glCompileShader(geometryShader);

	// vO̍쐬
	program = glCreateProgram();

	// vOւ̃VF[_̓o^
	glAttachShader(program, fragmentShader);
	glAttachShader(program, vertexShader);
	glAttachShader(program, geometryShader);

	// Op`͂ĎOp`o͂
	glProgramParameteriEXT(program,GL_GEOMETRY_INPUT_TYPE_EXT, INPUT_TYPE);
	glProgramParameteriEXT(program,GL_GEOMETRY_OUTPUT_TYPE_EXT, OUTPUT_TYPE);

	// WIgVF[_ŏo͂ő咸_̎擾Ɛݒ
	int temp;
	glGetIntegerv(GL_MAX_GEOMETRY_OUTPUT_VERTICES_EXT,&temp);
	glProgramParameteriEXT(program,GL_GEOMETRY_VERTICES_OUT_EXT,temp);

	// vÕNƎgpJn
	glLinkProgram(program);
	glUseProgram(program);

	// fobOpO\
	printShaderInfoLog(vertexShader);
	printShaderInfoLog(fragmentShader);
	printShaderInfoLog(geometryShader);
	printProgramInfoLog(program);
}

void init()
{
    // OpenGL̏ݒ
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0 , GL_POSITION , lightPos);
	glLightfv(GL_LIGHT0 , GL_DIFFUSE, lightCol);
	glLightfv(GL_LIGHT0 , GL_AMBIENT, lightAmb);
	glLightfv(GL_LIGHT0 , GL_SPECULAR, lightSpecular);
	glLightfv(GL_LIGHT0 , GL_SHININESS, &shininess);
	glEnable(GL_DEPTH_TEST);
	glClearColor(1.0, 1.0, 1.0, 1.0);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, diffuse);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, lightSpecular);
	glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, &shininess);
	// ʏL
	glEnable(GL_CULL_FACE);
}

int main(int argc, char **argv) 
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(10, 10);
	glutInitWindowSize(640, 480);
	glutCreateWindow("GPU");

	glutDisplayFunc(renderScene);
	glutIdleFunc(renderScene);
	glutReshapeFunc(changeSize);
	glutKeyboardFunc(processNormalKeys);

	init();

	glewInit();
	if (glewIsSupported("GL_VERSION_2_1"))
	{
		printf("Ready for OpenGL 2.1\n");
	}
	else 
	{
		printf("OpenGL 2.1 not supported\n");
		exit(1);
	}
	if (GLEW_ARB_vertex_shader && GLEW_ARB_fragment_shader && GL_EXT_geometry_shader4)
	{
		printf("Ready for GLSL - vertex, fragment, and geometry units\n");
	}
	else
	{
		printf("Not totally ready :( \n");
		exit(1);
	}

	setShaders();

	glutMainLoop();

	// just for compatibiliy purposes
	return 0;

}
